<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Blogger - Article</title>
    <link rel="stylesheet" href="{{ url_for('static' , filename = 'css/style.css') }}">
    <script src="{{ url_for('static' , filename = '/js/jquery-3.6.0.min.js')}}"></script>
</head>
<body align='center'>
    <h1>Blogger - Article</h1>
    <div align="center">
        <table border="1">
            <thead>
            <tr>
                <th width='100'>title</th>
                <th width='100'>author</th>
                <th width='300'>date</th>
                <th width='100'>action</th>
            </tr>
            </thead>
            <tbody align="center">
                {% for article in lstArticle %}
                <tr >
                    <td> {{ article.title }} </td>
                    <td> {{ article.author }} </td>
                    <td> {{ article.date }} </td>
                    <td>
                        <button name='btnShow' data-index='{{ loop.index }}'>show</button>
                    </td>
                </tr>
                {% endfor %}
            </tbody>
        </table>
    </div>
    <hr>
    <div id=actionDiv>
        <button id="btnNew">新增</button>
        <button id="btnEdit" class='hide'>修改</button>
        <button id="btnDelete" class='hide'>刪除</button>
    </div>
    <br>
    <div id="showDiv" class="article hide" align='center'>
        <h2 id='txt_title'></h2>
        <div id='txt_content'></div>
        <p>Author : <span id='txt_author'></span>&nbsp;&nbsp;&nbsp;Date : <span id='txt_date'></span></p>
    </div>
    <div id="editDiv" class="hide">
        <form id='editForm' action="/add" method="post">
            <input type="hidden" id='edt_id' name='id'>
            <label for="title">標題 : </label>
            <input type='text' id='edt_title' name='title'/><br><br>
            <textarea rows="10" cols="75" id='edt_content' name="content"></textarea><br><br>
        </form>
    </div>
    <h2 id='msg'></h2>
    <button id='btnNo' class='hide'>取消</button>
    <button id='btnYes' class='hide'>確認</button>
    <script type= text/javascript>
        $(function(){
            $btnShow = $('[name=btnShow]');
            $btnNew = $('#btnNew');
            $btnEdit = $('#btnEdit');
            $btnDelete = $('#btnDelete');

            $btnYes = $('#btnYes');
            $btnNo = $('#btnNo');

            $showDiv = $('#showDiv');
            $editDiv = $('#editDiv');
            $msg = $('#msg')
            
            $txtTitle = $('#txt_title');
            $txtContent = $('#txt_content');
            $txtAuthor = $('#txt_author');
            $txtDate = $('#txt_date');

            $edtId = $('#edt_id');
            $edtTitle = $('#edt_title');
            $edtContent = $('#edt_content');

            $editForm = $('#editForm');

            var lstArticle = {{ lstArticle | tojson }};
            var index = -1;

            $btnShow.off('click').on('click' , function(){
                index = $(this).attr('data-index') - 1;

                let article = lstArticle[index];

                $edtId.val(article.id);
                $edtTitle.val(article.title);
                $edtContent.val(article.content);

                $txtTitle.html(article.title);
                $txtContent.html(article.content.replace(/(\r\n)|(\n)/g,'<br>'));
                $txtAuthor.html(article.author);
                $txtDate.html(article.date);

                $btnNew.hide();
                $btnEdit.show();
                $btnDelete.show();

                $showDiv.show();
                $editDiv.hide();
                $btnYes.hide();
                $btnNo.show();
            });

            $btnNew.off('click').on('click' , function(){
                $edtTitle.text('');
                $edtContent.text('');

                $editForm.attr('action' , '/add');
                $editForm.attr('method' , 'post');

                $btnNew.hide();
                $btnEdit.hide();
                $btnDelete.hide();

                $showDiv.hide();
                $editDiv.show();
                $btnYes.show();
                $btnNo.show();
            });

            $btnEdit.off('click').on('click' , function(){
                $editForm.attr('action' , '/edit');
                $editForm.attr('method' , 'post');

                $btnNew.hide();
                $btnEdit.hide();
                $btnDelete.hide();                

                $showDiv.hide();
                $editDiv.show();
                $btnYes.show();
                $btnNo.show();
            });

            $btnDelete.off('click').on('click' , function(){
                $msg.text('確定 ?');
                $msg.show();

                $editForm.attr('action' , '/delete');
                $editForm.attr('method' , 'post');

                $btnNew.hide();
                $btnEdit.hide();
                $btnDelete.hide();  

                $showDiv.hide();
                $editDiv.hide();
                $btnYes.show();
                $btnNo.show();
            });

            $btnYes.off('click').on('click' , function() {
                $editForm.submit();
                $msg.hide();
            });

            $btnNo.off('click').on('click' , function() {

                $edtId.val('');
                $edtTitle.val('');
                $edtContent.val('');

                $btnNew.show();
                $btnEdit.hide();
                $btnDelete.hide();
                $showDiv.hide();
                $editDiv.hide();
                $btnYes.hide();
                $btnNo.hide();
                $msg.hide();
            });

        });
    </script>
</body>
</html>
